package com.example.thomasbet;

import android.content.Context;
import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;

import android.os.Handler;
import android.os.Looper;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

import com.example.thomasbet.RestClients.BlogRestClient;
import com.example.thomasbet.RestClients.StrategyRestClient;
import com.example.thomasbet.customDataTypes.blog.ModelBlog;
import com.example.thomasbet.customDataTypes.strategy.ModelStrategy;

import java.util.concurrent.Executor;
import java.util.concurrent.Executors;

public class BlogFragmentNewArticle extends Fragment {
    private Button publishArticle;
    private MainActivity mainActivity;
    private EditText titleText;
    private EditText bodyText;

    public BlogFragmentNewArticle() {
        // Required empty public constructor
    }

    public static BlogFragmentNewArticle newInstance() {
        BlogFragmentNewArticle fragment = new BlogFragmentNewArticle();
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public void onAttach(@NonNull Context context) {
        super.onAttach(context);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View view = inflater.inflate(R.layout.fragment_blog_new_article, container, false);
        this.publishArticle = view.findViewById(R.id.blog_article_publish);
        this.titleText = view.findViewById(R.id.blog_AddArticle_title);
        this.bodyText = view.findViewById(R.id.blog_AddArticle_body);
        this.mainActivity = (MainActivity) getActivity();

        publishArticle.setOnClickListener(click -> {
            createArticle();
        });

        return view;
    }



    //přidávání nového článku
    public void createArticle(){
        ModelBlog modelBlog = new ModelBlog();
        modelBlog.setUserId(mainActivity.getUser().getId());
        modelBlog.setTitle(titleText.getText().toString());
        modelBlog.setBody(bodyText.getText().toString());
        modelBlog.setDateNew(System.currentTimeMillis());
        modelBlog.setDateEdit(System.currentTimeMillis());

        callRestApiSave(modelBlog);
    }

    //REST call pro přidávání nového článku
    public void callRestApiSave(ModelBlog modelBlog){
        Executor executor = Executors.newSingleThreadExecutor();
        Handler handler = new Handler(Looper.getMainLooper());

        executor.execute(new Runnable() {
            @Override
            public void run() {
                try {
                    boolean result = BlogRestClient.CREATE_BLOG(modelBlog);
                    int pageCount = BlogRestClient.GET_PAGES_COUNT(2, Long.valueOf(mainActivity.getUser().getId()), false);
                    handler.post(new Runnable() {
                        @Override
                        public void run() {
                            if(result){
                                Toast.makeText(mainActivity, "Článek byl vytvořen", Toast.LENGTH_SHORT).show();
                                mainActivity.changeFragment(new BlogFragment(pageCount-1, Long.valueOf(0)));
                            }else{
                                Toast.makeText(mainActivity, "Něco se pokazilo, zkuste to prosím později", Toast.LENGTH_SHORT).show();
                            }
                        }
                    });
                } catch (Exception e) {
                    System.out.println(e);
                }
            }
        });
    }
}