package com.example.thomasbet.RestClients;

import com.example.thomasbet.customDataTypes.betting.Bet;
import com.example.thomasbet.customDataTypes.blog.ModelBlog;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

import org.json.JSONArray;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

public class BetRestClient {

    //vytvoření sázky
    public static boolean CREATE_BET(Bet bet) throws Exception {
        URL url = new URL("http://10.0.2.2:8080/api/bets");

        Gson gson = new Gson();
        String json = gson.toJson(bet);
        System.out.println(json);


        try {
            HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
            urlConnection.setRequestMethod("POST");
            urlConnection.setRequestProperty("Content-Type", "application/json");
            urlConnection.setDoOutput(true);
            urlConnection.connect();

            OutputStream outputStream = urlConnection.getOutputStream();
            outputStream.write(json.getBytes());
            outputStream.flush();
            outputStream.close();

            StringBuilder jsonResponse = new StringBuilder();

            int responseCode = urlConnection.getResponseCode();
            if (responseCode == HttpURLConnection.HTTP_OK) {
                /*
                InputStream inputStream = urlConnection.getInputStream();
                BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream));
                String line;
                while ((line = bufferedReader.readLine()) != null) {
                    jsonResponse.append(line);
                }
                */
                return true;
            }else{
                return false;
            }
        }catch(Exception E){
            return false;
        }
    }



    //získání sázek podle uživatele
    public static List<Bet> GET_MY_BETS(int offset, int page, Long userId) throws Exception {
        String url = "http://10.0.2.2:8080/api/bets?userId=";
        url = url.concat(String.valueOf(userId));
        url = url.concat("&offset=" + String.valueOf(offset));
        url = url.concat("&page=" + String.valueOf(page));

        URL apiUrl = new URL(url);


        ArrayList<Bet> betArrayList = new ArrayList<>();

        StringBuilder jsonResponse = new StringBuilder();

        try{
            HttpURLConnection urlConnection = (HttpURLConnection) apiUrl.openConnection();
            urlConnection.setRequestMethod("GET");
            urlConnection.setRequestProperty("Accept", "application/json");
            //urlConnection.connect();
            BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(urlConnection.getInputStream()));

            String line;
            while ((line = bufferedReader.readLine()) != null) {
                jsonResponse.append(line);
            }
            urlConnection.disconnect();

            JSONObject jsonResponseObject = new JSONObject(jsonResponse.toString());
            JSONObject responseKey = new JSONObject(jsonResponseObject.get("response").toString());
            JSONArray jsonArray = new JSONArray(responseKey.get("content").toString());

            Gson gson = new GsonBuilder()
                    .serializeNulls()
                    .create();

            for (int i=0; i<jsonArray.length(); i++) {
                JSONObject betObject = jsonArray.getJSONObject(i);
                System.out.println("BET JSON OBJECT: " + betObject.toString());
                Bet bet = gson.fromJson(betObject.toString(), Bet.class);
                System.out.println("BET: " + bet.toString());
                betArrayList.add(bet);

            }

            return betArrayList;
        } catch (Exception e){
            e.printStackTrace();
            throw e;
        }
    }

    //získání počtu stránek
    public static int GET_PAGES_COUNT(int offset, Long userId) throws Exception {
        String url = "http://10.0.2.2:8080/api/bets/count?offset=";
        url = url.concat(String.valueOf(offset));
        url = url.concat("&userId=" + String.valueOf(userId));

        URL apiUrl = new URL(url);

        StringBuilder jsonResponse = new StringBuilder();

        try{
            HttpURLConnection urlConnection = (HttpURLConnection) apiUrl.openConnection();
            urlConnection.setRequestMethod("GET");
            urlConnection.setRequestProperty("Accept", "application/json");
            //urlConnection.connect();
            BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(urlConnection.getInputStream()));

            String line;
            while ((line = bufferedReader.readLine()) != null) {
                jsonResponse.append(line);
            }
            urlConnection.disconnect();


            return Integer.parseInt(jsonResponse.toString());
        } catch (Exception e){
            e.printStackTrace();
            throw e;
        }
    }
}
