package com.example.thomasbet;

import android.os.Bundle;

import androidx.fragment.app.Fragment;

import android.os.Handler;
import android.os.Looper;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

import com.example.thomasbet.RestClients.StrategyRestClient;
import com.example.thomasbet.customDataTypes.strategy.ModelStrategy;

import java.util.concurrent.Executor;
import java.util.concurrent.Executors;


public class StrategyFragmentNewArticle extends Fragment {
    Spinner trust;
    EditText title, body, bet;
    MainActivity mainActivity;

    Button previewStrategy, publishStrategy;



    public StrategyFragmentNewArticle() {
        // Required empty public constructor
    }


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_strategy_new_article, container, false);
        mainActivity = (MainActivity) getActivity();

        trust = view.findViewById(R.id.strategy_AddStrategy_trust);
        ArrayAdapter<CharSequence> adapter = ArrayAdapter.createFromResource(getContext(),R.array.spinner_betTrust, android.R.layout.simple_spinner_item);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        trust.setAdapter(adapter);

        title = view.findViewById(R.id.strategy_AddStrategy_title);
        body = view.findViewById(R.id.strategy_AddStrategy_body);
        bet = view.findViewById(R.id.strategy_bet);
        //previewStrategy = view.findViewById(R.id.strategy_AddStrategy_preview);
        publishStrategy = view.findViewById(R.id.strategy_AddStrategy_publish);

        publishStrategy.setOnClickListener(click -> {
            createStrategy();
        });




        return view;
    }

    public void createStrategy(){
        ModelStrategy modelPost = new ModelStrategy();
        modelPost.setUserId(mainActivity.getUser().getId());
        modelPost.setTitle(title.getText().toString());
        modelPost.setBody(body.getText().toString());
        modelPost.setBet(bet.getText().toString());
        modelPost.setTrust(Integer.parseInt((String) trust.getSelectedItem()));
        modelPost.setDateNew(System.currentTimeMillis());
        modelPost.setDateEdit(System.currentTimeMillis());

        callRestApiSave(modelPost);
    }

    public void callRestApiSave(ModelStrategy modelPost){
        Executor executor = Executors.newSingleThreadExecutor();
        Handler handler = new Handler(Looper.getMainLooper());

        executor.execute(new Runnable() {
            @Override
            public void run() {
                try {
                    boolean result = StrategyRestClient.CREATE_STRATEGY(modelPost);
                    int pageCount = StrategyRestClient.GET_PAGES_COUNT(2, Long.valueOf(mainActivity.getUser().getId()), false);
                    handler.post(new Runnable() {
                        @Override
                        public void run() {
                            if(result){
                                Toast.makeText(mainActivity, "Strategie byla vytvořena", Toast.LENGTH_SHORT).show();
                                mainActivity.changeFragment(new StrategyFragment(pageCount-1, Long.valueOf(0)));
                            }else{
                                Toast.makeText(mainActivity, "Něco se pokazilo, zkuste to prosím později", Toast.LENGTH_SHORT).show();
                            }
                        }
                    });
                } catch (Exception e) {
                    System.out.println(e);
                }
            }
        });
    }
}