package com.example.thomasbet.customDataTypes.event;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.example.thomasbet.AllMatchesFragment;
import com.example.thomasbet.MainActivity;
import com.example.thomasbet.MatchDetailsFragment;
import com.example.thomasbet.R;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

public class AdapterEventUpcoming extends RecyclerView.Adapter<AdapterEventUpcoming.HolderEventUpcoming>{

    private Context context;
    private MainActivity mainActivity;
    private AllMatchesFragment currentFragment;
    private ArrayList<ModelEvent> eventArrayList = new ArrayList<>();

    public AdapterEventUpcoming(Context context, MainActivity mainActivity, AllMatchesFragment eventFragment) {
        this.context = context;
        this.mainActivity = mainActivity;
        this.currentFragment = eventFragment;
    }

    @NonNull
    @Override
    public AdapterEventUpcoming.HolderEventUpcoming onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(context).inflate(R.layout.allmatchesbody, parent, false);
        return new AdapterEventUpcoming.HolderEventUpcoming(view);
    }

    public void addModelEvent(ModelEvent modelEvent){
        this.eventArrayList.add(modelEvent);
    }

    public void removeModels(){
        eventArrayList.clear();
    }

    //struktura rozvrhu zápasů
    @Override
    public void onBindViewHolder(@NonNull AdapterEventUpcoming.HolderEventUpcoming holder, int position) {
        ModelEvent model = eventArrayList.get(position);

        holder.category.setText(model.getSportType());
        SimpleDateFormat sdf = new SimpleDateFormat("dd-MM-yyyy HH:mm:ss");
        holder.commenceDate.setText(sdf.format(new Date(model.getCommenceTime())));
        holder.league.setText(model.getLeague());
        holder.title1.setText(model.getHomeTeam());
        holder.title2.setText(model.getAwayTeam());

        holder.title1.setOnClickListener(click -> {
            mainActivity.changeFragment(new MatchDetailsFragment(holder, model.getEventId()));
        });

        holder.title2.setOnClickListener(click -> {
            mainActivity.changeFragment(new MatchDetailsFragment(holder, model.getEventId()));
        });
    }


    @Override
    public int getItemCount() {
        return eventArrayList.size();
    }

    public ArrayList<ModelEvent> getEventArrayList() {
        return eventArrayList;
    }





    public class HolderEventUpcoming extends RecyclerView.ViewHolder{

        //vázání s XML textviews
        TextView category, commenceDate, league, title1, title2;
        public HolderEventUpcoming(@NonNull View itemView) {
            super(itemView);
            category = itemView.findViewById(R.id.allmatches_category);
            commenceDate = itemView.findViewById(R.id.allmatches_playdate);
            league = itemView.findViewById(R.id.allmatches_league);
            title1 = itemView.findViewById(R.id.allmatches_title1);
            title2 = itemView.findViewById(R.id.allmatches_title2);
        }

        public TextView getCategory(){
            return this.category;
        }

        public TextView getTitle1() {
            return title1;
        }

        public void setTitle1(TextView title1) {
            this.title1 = title1;
        }

        public TextView getTitle2() {
            return title2;
        }

        public void setTitle2(TextView title2) {
            this.title2 = title2;
        }

        public TextView getCommenceDate(){
            return this.commenceDate;
        }

        public TextView getLeague(){
            return this.league;
        }
    }
}
