package com.example.thomasbet.customDataTypes.event;

import com.google.gson.annotations.SerializedName;

//model Entity
public class ModelEvent {

    @SerializedName("id")
    private String eventId;

    @SerializedName("sport_key")
    private String sportKey;

    @SerializedName("sport_title")
    private String league;

    @SerializedName("commence_time")
    private Long commenceTime;

    @SerializedName("home_team")
    private String homeTeam;

    @SerializedName("away_team")
    private String awayTeam;

    @SerializedName("sport_type")
    private String sportType;

    @SerializedName("home_team_score")
    private Integer homeTeamScore;

    @SerializedName("away_team_score")
    private Integer awayTeamScore;

    public ModelEvent() {
    }

    public ModelEvent(String eventId, String sportKey, String league, Long commenceTime, String homeTeam, String awayTeam, String sportType, Integer homeTeamScore, Integer awayTeamScore) {
        this.eventId = eventId;
        this.sportKey = sportKey;
        this.league = league;
        this.commenceTime = commenceTime;
        this.homeTeam = homeTeam;
        this.awayTeam = awayTeam;
        this.sportType = sportType;
        this.homeTeamScore = homeTeamScore;
        this.awayTeamScore = awayTeamScore;
    }


    public ModelEvent(String sportKey, String league, Long commenceTime, String homeTeam, String awayTeam, String sportType, Integer homeTeamScore, Integer awayTeamScore) {
        this.sportKey = sportKey;
        this.league = league;
        this.commenceTime = commenceTime;
        this.homeTeam = homeTeam;
        this.awayTeam = awayTeam;
        this.sportType = sportType;
        this.homeTeamScore = homeTeamScore;
        this.awayTeamScore = awayTeamScore;
    }

    public String getEventId() {
        return eventId;
    }

    public void setEventId(String eventId) {
        this.eventId = eventId;
    }

    public String getSportKey() {
        return sportKey;
    }

    public void setSportKey(String sportKey) {
        this.sportKey = sportKey;
    }

    public String getLeague() {
        return league;
    }

    public void setLeague(String league) {
        this.league = league;
    }

    public Long getCommenceTime() {
        return commenceTime;
    }

    public void setCommenceTime(Long commenceTime) {
        this.commenceTime = commenceTime;
    }

    public String getHomeTeam() {
        return homeTeam;
    }

    public void setHomeTeam(String homeTeam) {
        this.homeTeam = homeTeam;
    }

    public String getAwayTeam() {
        return awayTeam;
    }

    public void setAwayTeam(String awayTeam) {
        this.awayTeam = awayTeam;
    }

    public String getSportType() {
        return sportType;
    }

    public void setSportType(String sportType) {
        this.sportType = sportType;
    }

    public Integer getHomeTeamScore() {
        return homeTeamScore;
    }

    public void setHomeTeamScore(Integer homeTeamScore) {
        this.homeTeamScore = homeTeamScore;
    }

    public Integer getAwayTeamScore() {
        return awayTeamScore;
    }

    public void setAwayTeamScore(Integer awayTeamScore) {
        this.awayTeamScore = awayTeamScore;
    }

    @Override
    public String toString() {
        return "ModelEvent{" +
                "eventId='" + eventId + '\'' +
                ", sportKey='" + sportKey + '\'' +
                ", league='" + league + '\'' +
                ", commenceTime=" + commenceTime +
                ", homeTeam='" + homeTeam + '\'' +
                ", awayTeam='" + awayTeam + '\'' +
                ", sportType='" + sportType + '\'' +
                ", homeTeamScore=" + homeTeamScore +
                ", awayTeamScore=" + awayTeamScore +
                '}';
    }
}
